#!/usr/bin/python2.6
"""Backup To-Do: save the history of your Toodledo tasks, folders, etc.

http://erikdemaine.org/software/backuptodo/

== MIT License ==

Copyright (c) 2011 Erik Demaine

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.

"""

import getpass, os
import json
import toodledo

version = 0  ## must be integer
account_json = 'account.json'

class Toodledo (toodledo.Toodledo):
  appid = 'backuptodo'
  apptoken = 'api4ebaa8c761d3c'
  appversion = version

  def backup (self):
    new = 0
    deleted = 0
    updates = self.updates ()
    back = open (os.path.join (self.dbdir, 'backup-%s.txt' % self.email), 'a')
    try:
      for TYPE in self.TYPES:
        for task in updates.get (TYPE, []):
          task['TYPE'] = TYPE[:-1]
          back.write (json.dumps (task) + '\n')
    finally:
      back.close ()
    return dict ((TYPE, len (updates.get (TYPE, [])))
                 for TYPE in self.TYPES)

entered_credentials = False
if os.path.exists (account_json):
  account = json.load (open (account_json, 'r'))
else:
  print 'Enter your Toodledo credentials:'
  account = {
    'email': raw_input ('Email address: '),
    'password': getpass.getpass ('Password: ')
  }
  entered_credentials = True

toodledo = Toodledo ('backuptodo.db', account['email'], account['password'])
counts = toodledo.backup ()
print '%d task updates, %d task deletions, %d folders, %d contexts, %d goals, %d locations' % (counts['tasks'], counts['deleted_tasks'], counts['folders'], counts['contexts'], counts['goals'], counts['locations'])

if entered_credentials:
  yn = raw_input ('Save these credentials to %r for future use (y/n)? ' % account_json)
  if yn.lower ().startswith ('y'):
    f = open (account_json, 'w')
    json.dump (account, f)
    f.close ()
